SoCylinder(3)

NAME
SoCylinder - The SoCylinder class is for rendering cylinder shapes.

SYNOPSIS

#include <Inventor/nodes/SoCylinder.h>

Inherits SoShape.

  Public Types
enum Part { SIDES = 0x1, TOP = 0x2, BOTTOM = 0x4, ALL = SIDES|TOP|BOTTOM }

  Public Member Functions
virtual SoType getTypeId (void) const
SoCylinder (void)
void addPart (SoCylinder::Part part)
void removePart (SoCylinder::Part part)
SbBool hasPart (SoCylinder::Part part) const
virtual void rayPick (SoRayPickAction *action)
virtual void getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual void GLRender (SoGLRenderAction *action)

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)

  Public Attributes
SoSFFloat radius
SoSFFloat height
SoSFBitMask parts

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoCylinder ()
virtual void generatePrimitives (SoAction *action)
virtual void computeBBox (SoAction *action, SbBox3f &box, SbVec3f &center)

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)

  Additional Inherited Members

Detailed Description

The SoCylinder class is for rendering cylinder shapes. Insert a cylinder shape into the scene graph. The cylinder is rendered with the current material, texture and draw style settings (if any, otherwise the default settings are used).

The SoCylinder node class is provided as a convenient abstraction for the application programmer to use 'complex' shapes of this type without having to do the tessellation to polygons and other low level programming herself.

A cylinder is visualized by the underlying rendering system by first tessellating the conceptual cylinder into a set of polygons. To control the trade-off between an as much as possible correct visual appearance of the cylinder versus fast rendering, use an SoComplexity node to influence the number of polygons generated from the tessellation process. (The higher the complexity value, the more polygons will be generated, the more rounded the sides of the cylinder will look.) Set the SoComplexity::value field to what you believe would be a good trade-off between correctness and speed for your particular application.

A nice trick for rendering a disc is to render an SoCylinder with SoCylinder::height set to zero:

#Inventor V2.1 ascii
ShapeHints { # to get two-sided lighting on the disc
   vertexOrdering COUNTERCLOCKWISE
   shapeType UNKNOWN_SHAPE_TYPE
}
Cylinder {
   height 0
   parts TOP
}

FILE FORMAT/DEFAULTS:

Cylinder {
    radius 1
    height 2
    parts (SIDES | TOP | BOTTOM)
}

See also
    SoCone, SoSphere, SoCube

Member Enumeration Documentation

  enum SoCylinder::Part
Enumerates the various parts of the cylinder, for setting inclusion or exclusion from the shape.

Enumerator

SIDES
    Sides of cylinder.

TOP Top of cylinder.

BOTTOM
    Bottom of cylinder.

ALL All parts.

Constructor & Destructor Documentation

  SoCylinder::SoCylinder (void)
Constructor.

  SoCylinder::~SoCylinder () [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoCylinder::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoCylinder::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Reimplemented from SoShape.

  const SoFieldData ** SoCylinder::getFieldDataPtr (void) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoCylinder::getFieldData (void) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoShape.

  void SoCylinder::initClass (void) [static]

  void SoCylinder::addPart (SoCylinder::Part part)
Add a part to the cylinder.

See also
    removePart(), hasPart()

  void SoCylinder::removePart (SoCylinder::Part part)
Remove a part from the cylinder.

See also
    addPart(), hasPart()

  SbBool SoCylinder::hasPart (SoCylinder::Part part) const
Returns TRUE if rendering of the given part is currently turned on.

See also
    addPart(), removePart()

  void SoCylinder::rayPick (SoRayPickAction * action) [virtual]
Calculates picked point based on primitives generated by subclasses.

Reimplemented from SoShape.

  void SoCylinder::getPrimitiveCount (SoGetPrimitiveCountAction * action) [virtual]
Action method for the SoGetPrimitiveCountAction.

Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action.

Nodes influencing how geometry nodes calculate their primitive count also override this method to change the relevant state variables.

Reimplemented from SoShape.

  void SoCylinder::GLRender (SoGLRenderAction * action) [virtual]
Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoShape.

  void SoCylinder::generatePrimitives (SoAction * action) [protected], [virtual]
The method implements action behavior for shape nodes for SoCallbackAction. It is invoked from SoShape::callback(). (Subclasses should not override SoNode::callback().)

The subclass implementations uses the convenience methods SoShape::beginShape(), SoShape::shapeVertex(), and SoShape::endShape(), with SoDetail instances, to pass the primitives making up the shape back to the caller.

Implements SoShape.

  void SoCylinder::computeBBox (SoAction * action, SbBox3f & box, SbVec3f & center) [protected], [virtual]
Implemented by SoShape subclasses to let the SoShape superclass know the exact size and weighted center point of the shape's bounding box.

The bounding box and center point should be calculated and returned in the local coordinate system.

The method implements action behavior for shape nodes for SoGetBoundingBoxAction. It is invoked from SoShape::getBoundingBox(). (Subclasses should not override SoNode::getBoundingBox().)

The box parameter sent in is guaranteed to be an empty box, while center is undefined upon function entry.

Implements SoShape.

Member Data Documentation

  SoSFFloat SoCylinder::radius
Radius of cylinder. Default value 1.0.

  SoSFFloat SoCylinder::height
Height of cylinder. Default is 2.0.

  SoSFBitMask SoCylinder::parts
Which parts to use for rendering, picking, etc. Defaults to SoCylinder::ALL.

Author

Generated automatically by Doxygen for Coin from the source code.